## ros-melodic-ws281x 0.0.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ws281x)

## Compile as C++11, supported in ROS Kinetic and newer
# add_compile_options(-std=c++11)

option(ROS_WS2811_MOCK_LIB "Use mock ws281x library instead of the real one" OFF)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  message_generation
  roscpp
  led_msgs
)

## System dependencies are found with CMake's conventions
# find_package(Boost REQUIRED COMPONENTS system)


## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

################################################
## Declare ROS messages, services and actions ##
################################################

## To declare and build messages, services or actions from within this
## package, follow these steps:
## * Let MSG_DEP_SET be the set of packages whose message types you use in
##   your messages/services/actions (e.g. std_msgs, actionlib_msgs, ...).
## * In the file package.xml:
##   * add a build_depend tag for "message_generation"
##   * add a build_depend and a exec_depend tag for each package in MSG_DEP_SET
##   * If MSG_DEP_SET isn't empty the following dependency has been pulled in
##     but can be declared for certainty nonetheless:
##     * add a exec_depend tag for "message_runtime"
## * In this file (CMakeLists.txt):
##   * add "message_generation" and every package in MSG_DEP_SET to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * add "message_runtime" and every package in MSG_DEP_SET to
##     catkin_package(CATKIN_DEPENDS ...)
##   * uncomment the add_*_files sections below as needed
##     and list every .msg/.srv/.action file to be processed
##   * uncomment the generate_messages entry below
##   * add every package in MSG_DEP_SET to generate_messages(DEPENDENCIES ...)

## Generate messages in the 'msg' folder
# add_message_files(
#   FILES
# )

## Generate services in the 'srv' folder
add_service_files(
  FILES
  SetGamma.srv
)

## Generate actions in the 'action' folder
# add_action_files(
#   FILES
#   Action1.action
#   Action2.action
# )

## Generate added messages and services with any dependencies listed here
generate_messages(
  DEPENDENCIES
  std_msgs  # Or other packages containing msgs
)

################################################
## Declare ROS dynamic reconfigure parameters ##
################################################

## To declare and build dynamic reconfigure parameters within this
## package, follow these steps:
## * In the file package.xml:
##   * add a build_depend and a exec_depend tag for "dynamic_reconfigure"
## * In this file (CMakeLists.txt):
##   * add "dynamic_reconfigure" to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * uncomment the "generate_dynamic_reconfigure_options" section below
##     and list every .cfg file to be processed

## Generate dynamic reconfigure parameters in the 'cfg' folder
# generate_dynamic_reconfigure_options(
#   cfg/DynReconf1.cfg
#   cfg/DynReconf2.cfg
# )

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if your package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
#  INCLUDE_DIRS include
#  LIBRARIES ros_ws281x
  CATKIN_DEPENDS message_generation roscpp led_msgs
#  DEPENDS system_lib
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
# include
  ${catkin_INCLUDE_DIRS}
)

add_subdirectory(vendor)

## Declare a C++ library
# add_library(${PROJECT_NAME}
#   src/${PROJECT_NAME}/ros_ws281x.cpp
# )

## Add cmake target dependencies of the library
## as an example, code may need to be generated before libraries
## either from message generation or dynamic reconfigure
# add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

## Declare a C++ executable
## With catkin_make all packages are built within a single CMake context
## The recommended prefix ensures that target names across packages don't collide
add_executable(${PROJECT_NAME}_node src/ws281x_node.cpp)
target_link_libraries(${PROJECT_NAME}_node rpi_ws281x)
target_compile_features(${PROJECT_NAME}_node PRIVATE
        cxx_nonstatic_member_init
        )

add_dependencies(${PROJECT_NAME}_node ${PROJECT_NAME}_generate_messages_cpp)

## Rename C++ executable without prefix
## The above recommended prefix causes long target names, the following renames the
## target back to the shorter version for ease of user use
## e.g. "rosrun someones_pkg node" instead of "rosrun someones_pkg someones_pkg_node"
# set_target_properties(${PROJECT_NAME}_node PROPERTIES OUTPUT_NAME node PREFIX "")

## Add cmake target dependencies of the executable
## same as for the library above
add_dependencies(${PROJECT_NAME}_node ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME}_node
  ${catkin_LIBRARIES}
)

# Since we're using SUID bits, we need to leave rpath in for stripped binaries
set_target_properties(${PROJECT_NAME}_node PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
# install(DIRECTORY include/${PROJECT_NAME}/
#   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
#   FILES_MATCHING PATTERN "*.h"
#   PATTERN ".svn" EXCLUDE
# )

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES
  launch/example.launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)

# Prepare node for packaging
# FIXME: better checks for packaging?
if("${CATKIN_BUILD_BINARY_PACKAGE}" EQUAL "1")
  message(STATUS "Building for ROS distro: $ENV{ROS_DISTRO}")
  set(ROSDISTRO $ENV{ROS_DISTRO})

  configure_file(scripts/postinst.in postinst)

  install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/postinst
    DESTINATION /DEBIAN
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  )
endif()

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
# catkin_add_gtest(${PROJECT_NAME}-test test/test_ros_ws281x.cpp)
# if(TARGET ${PROJECT_NAME}-test)
#   target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})
# endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== vendor/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(ws281x_vendor)

add_library(rpi_ws281x STATIC "")

message(STATUS "Building for ${CMAKE_SYSTEM_PROCESSOR}")
if (${ROS_WS2811_MOCK_LIB})
    message(STATUS "Using mock rpi_ws281x library")
    target_sources(rpi_ws281x PRIVATE
            rpi_ws281x_mock/pwm.cpp
            rpi_ws281x_mock/rpihw.cpp
            rpi_ws281x_mock/ws2811.cpp
            )
    target_compile_features(rpi_ws281x PRIVATE
            cxx_generalized_initializers
            )
    target_include_directories(rpi_ws281x PUBLIC
            rpi_ws281x_mock
            )
else()
    message(STATUS "Using real rpi_ws281x library")
    target_sources(rpi_ws281x PRIVATE
            rpi_ws281x/dma.c
            rpi_ws281x/mailbox.c
            rpi_ws281x/pcm.c
            rpi_ws281x/pwm.c
            rpi_ws281x/rpihw.c
            rpi_ws281x/ws2811.c
            )
    target_include_directories(rpi_ws281x PUBLIC
            rpi_ws281x
            )
endif()

=== vendor/rpi_ws281x/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

# read and parse version file
file(READ version PROJECT_VERSION)
string(STRIP ${PROJECT_VERSION} PROJECT_VERSION)
string(REGEX REPLACE "([0-9]+)\\.[0-9]+\\.[0-9]+" "\\1" VERSION_MAJOR ${PROJECT_VERSION})
string(REGEX REPLACE "[0-9]+\\.([0-9]+)\\.[0-9]+" "\\1" VERSION_MINOR ${PROJECT_VERSION})
string(REGEX REPLACE "[0-9]+\\.[0-9]+\\.([0-9]+)" "\\1" VERSION_MICRO ${PROJECT_VERSION})

set(HEADERDEF "${VERSION_MAJOR}_${VERSION_MINOR}_${VERSION_MICRO}")

project(rpi_ws281x VERSION ${PROJECT_VERSION})

option(BUILD_SHARED "Build as shared library" OFF)
option(BUILD_TEST "Build test application" ON)

set(CMAKE_C_STANDARD 11)

set(LIB_TARGET ws2811)
set(TEST_TARGET test)

set(LIB_PUBLIC_HEADERS
    ws2811.h
    rpihw.h
    pwm.h
    clk.h
    dma.h
    gpio.h
    mailbox.h
    pcm.h
)

set(LIB_SOURCES
    mailbox.c
    ws2811.c
    pwm.c
    pcm.c
    dma.c
    rpihw.c
)

set(TEST_SOURCES
    main.c
)

configure_file(version.h.in version.h)

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/pkg-config.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/libws2811.pc"
    @ONLY
)

set(DEST_HEADERS_DIR include/ws2811)
set(DEST_LIB_DIR lib)

if(BUILD_SHARED)
    add_library(${LIB_TARGET} SHARED ${LIB_SOURCES})
else()
    add_library(${LIB_TARGET} ${LIB_SOURCES})
endif()

target_link_libraries(${LIB_TARGET} m)
set_target_properties(${LIB_TARGET} PROPERTIES PUBLIC_HEADER "${LIB_PUBLIC_HEADERS}")

install(TARGETS ${LIB_TARGET}
    ARCHIVE DESTINATION ${DEST_LIB_DIR}
    PUBLIC_HEADER DESTINATION ${DEST_HEADERS_DIR}
)

INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/libws2811.pc"
        DESTINATION lib/pkgconfig)

if(BUILD_TEST)
    include_directories(${CMAKE_CURRENT_BINARY_DIR})

    add_executable(${TEST_TARGET} ${TEST_SOURCES})
    target_link_libraries(${TEST_TARGET} ${LIB_TARGET})
endif()

=== debian/changelog ===
ros-melodic-ws281x (0.0.11-1bionic) bionic; urgency=high

  * Added ros_environment build dependency

 -- Oleg Kalachev <okalachev@gmail.com>  Fri, 21 May 2021 07:00:00 -0000

ros-melodic-ws281x (0.0.10-1bionic) bionic; urgency=high

  * Update native library

 -- Oleg Kalachev <okalachev@gmail.com>  Fri, 02 Apr 2021 07:00:00 -0000

ros-melodic-ws281x (0.0.9-1bionic) bionic; urgency=high

  * Restore lost rpi_ws281x library files

 -- sfalexrog <sfalexrog@gmail.com>  Thu, 28 Jan 2021 08:00:00 -0000

ros-melodic-ws281x (0.0.8-1bionic) bionic; urgency=high

  * Update native library

 -- sfalexrog <sfalexrog@gmail.com>  Thu, 28 Jan 2021 08:00:00 -0000

ros-melodic-ws281x (0.0.7-1bionic) bionic; urgency=high

  * Update native library
  * Fix 64-bit checks

 -- sfalexrog <sfalexrog@gmail.com>  Fri, 11 Sep 2020 07:00:00 -0000

ros-melodic-ws281x (0.0.6-1bionic) bionic; urgency=high

  * Update native library

 -- sfalexrog <sfalexrog@gmail.com>  Wed, 05 Feb 2020 08:00:00 -0000

ros-melodic-ws281x (0.0.5-1bionic) bionic; urgency=high

  * Shut LED strip down on TERM signal

 -- sfalexrog <sfalexrog@gmail.com>  Thu, 14 Nov 2019 08:00:00 -0000

ros-melodic-ws281x (0.0.4-1bionic) bionic; urgency=high

  * Prevent CMake from stripping rpath

 -- sfalexrog <sfalexrog@gmail.com>  Thu, 29 Aug 2019 07:00:00 -0000

ros-melodic-ws281x (0.0.3-1bionic) bionic; urgency=high

  * Generate postinst script

 -- sfalexrog <sfalexrog@gmail.com>  Thu, 29 Aug 2019 07:00:00 -0000

ros-melodic-ws281x (0.0.2-1bionic) bionic; urgency=high

  * Initial release

 -- sfalexrog <sfalexrog@gmail.com>  Wed, 28 Aug 2019 07:00:00 -0000

=== debian/control ===
Source: ros-melodic-ws281x
Section: misc
Priority: optional
Maintainer: Oleg Kalachev <okalachev@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-led-msgs, ros-melodic-message-generation, ros-melodic-ros-environment, ros-melodic-roscpp
Homepage: https://github.com/CopterExpress/ros_led
Standards-Version: 3.9.2

Package: ros-melodic-ws281x
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-led-msgs, ros-melodic-message-generation, ros-melodic-roscpp
Description: ROS node for rpi_ws281x LED strip driver

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-ws281x//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
